version: '3.8'

services:
    app:
        build:
            context: .
            dockerfile: .docker/backend.Dockerfile
        networks:
            - lan
        volumes:
            - .:/var/www/html
        depends_on:
            - database
    nginx:
        image: nginx:alpine
        ports:
            - "80:80"
        networks:
            - lan
        volumes:
            - ./public:/var/www/html/public
            - ./storage/app:/var/www/html/storage/app
            - .docker/default.conf:/etc/nginx/conf.d/default.conf
        depends_on:
            - app
            - database
    node:
        build:
            context: .
            dockerfile: .docker/node.Dockerfile
        tty: true
        ports:
            - "5173:5173"
        working_dir: /var/www/html
        networks:
            - lan
        volumes:
            - .:/var/www/html
    database:
        image: mysql:8.0.4
        restart: always
        user: "${DB_USERNAME}:root"
        command: --default-authentication-plugin=mysql_native_password
        ports:
            - "${DB_PORT:-3306}:3306"
        environment:
            MYSQL_ROOT_PASSWORD: "${DB_PASSWORD}"
            MYSQL_DATABASE: "${DB_DATABASE}"
        networks:
            - lan
        volumes:
            - mysql-volume:/var/lib/mysql
networks:
    lan:
        driver: bridge
volumes:
    mysql-volume:
        driver: local
